%global _smp_ncpus_max 8
%define _enable_debug_packages %{nil}
%define debug_package          %{nil}

#define snap 20170317
%global pkglibdir	%{_prefix}/lib/dietlibc

%define rel 3

%ifarch %ix86 x86_64 aarch64
%bcond_without		ssp
%else
%bcond_with		ssp
%endif

%global myarch `uname -m | sed -e 's/i[4-9]86/i386/' -e 's/armv.*/arm/' -e 's!mips!%{_arch}!g'`

# This is eventually a biarch package, so no %%_lib for diethome
%define diethome %{_prefix}/lib/dietlibc

# Enable builds without testing (default shall always be testing)
%ifnarch aarch64
%define build_check		1
%else
%define build_check		0
%endif
%{expand: %{?_with_CHECK:	%%global build_check 1}}
%{expand: %{?_without_CHECK:	%%global build_check 0}}

Summary:	C library optimized for size
Name:		dietlibc
Version:	0.34
Release:	%mkrel %rel
License:	GPLv2
Group:		Development/Other
URL:		http://www.fefe.de/dietlibc/
Source0:	https://www.fefe.de/dietlibc/%{name}-%{version}.tar.xz
# all in one from RH:
Patch0:         dietlibc-insecure-defpath.patch
Patch1:		dietlibc-0.34-path.patch
Patch5:		dietlibc-0.22-net-ethernet.patch
Patch6:		dietlibc-0.24-rpc-types.patch
Patch17:	dietlibc-0.34-x86_64-stat64.patch
Patch18:	dietlibc-0.27-x86_64-lseek64.diff
Patch23:	dietlibc-0.33-biarch.patch
Patch26:	dietlibc-0.27-kernel2.6-types.patch
# (UPSTREAMED differently)
Patch33:	dietlibc-0.34-fix-strncmp.patch
# (cjw) from PLD, see http://gcc.gnu.org/bugzilla/show_bug.cgi?id=26374
Patch34:	dietlibc-0.29-ppc-gcc-ldbl128.patch
Patch113:	dietlibc-0.34-i386-types.patch

# (UPSTREAMED)
Patch300:	diet_arm_eabi_time.patch
Patch301:	diet_arm_create_module.patch
# (tv) add string.h's basename (prevent libkmod to segfault in basebame())
Patch322:	basename.diff
Patch323:	fix-test.patch

# From Debian
Patch400:	aarch64-define-__clone.diff

# (wally) fix test failures on aarch64
Patch500:	dummy-RDTSC-implementation.patch


%description
Small libc for building embedded applications.

%package	devel
Group:          Development/C
Summary:        Development files for dietlibc
Obsoletes:	%{name}
Provides:	%{name} = %{version}-%{release}

%description	devel
Small libc for building embedded applications.

%prep

%setup -q

find . -type d -perm 0700 -exec chmod 755 {} \;
find . -type f -perm 0555 -exec chmod 755 {} \;
find . -type f -perm 0444 -exec chmod 644 {} \;

for i in `find . -type d -name CVS` `find . -type f -name .cvs\*` `find . -type f -name .#\*`; do
    if [ -e "$i" ]; then rm -rf $i; fi >&/dev/null
done

# P9999 is from fedora 
%patch0 -p0 -b .rh
%patch1 -p0 -b .mdkconfig
%patch5 -p1 -b .net-ethernet
%patch6 -p1 -b .rpc-types
%patch17 -p1 -b .x86_64-stat64
#patch18 -p0 -b .x86_64-lseek64
#patch23 -p1 -b .biarch
#patch26 -p1 -b .kernel2.6-types
%patch33 -p1 -b .fix-strncmp

%patch300 -p1 -b .arm_time
%patch301 -p1 -b .arm_create_module
%patch322 -p1 -b .readdir_r
%patch323 -p1 -b .test

%patch400 -p1 -b .__clone

%patch500 -p1 -b .rdtsc

%patch113 -p0 -b .386_types

%if %{without ssp}
sed -i -e 's!^#define WANT_SSP$!// \0!g;
	   s!.*\(#define WANT_STACKGAP\).*!\1!g' dietfeatures.h
%global xtra_fixcflags	-fno-stack-protector
%else
%global xtra_fixcflags	%nil
%endif

rm -f x86_64/getpriority.S

#WANT_VALGRIND_SUPPORT
# disable unwanted features
cp dietfeatures.h{,.tv}
sed -i \
    -e '/#define WANT_\(LARGEFILE_BACKCOMPAT\|\LINKER_WARNINGS\|IPV6_DNS\|HIGH_PRECISION_MATH\|SAFEGUARDNT_LINKER_WARNINGS\|PLUGPLAY_DNS\|SAFEGUARD\)/d' \
    dietfeatures.h
 
# fix execute permission on test scripts
chmod a+x test/{dirent,inet,stdio,string,stdlib,time}/runtests.sh

%global fixcflags	-fomit-frame-pointer -fno-exceptions -fno-asynchronous-unwind-tables %xtra_fixcflags -Os -g3 -Werror-implicit-function-declaration -Wno-unused -Wno-switch
%global basemakeflags	prefix=%_prefix BINDIR=%{_bindir} MAN1DIR=%{_mandir}/man1 CFLAGS="$RPM_OPT_FLAGS %fixcflags $XTRA_CFLAGS" PDIET=%pkglibdir STRIP=: MYARCH=%{myarch}
%global makeflags	%basemakeflags

%build
%make_build %makeflags DEBUG=1

%check
# make and run the tests
%if %{build_check}
cd test; rm *.c.* || :
%ifarch %mips %arm
sed -i -e 's!cycles empty!empty!' Makefile
%endif
# fix build in chroot:
export DIETHOME="%{_builddir}/%{name}-%{version}"

find -name "Makefile" | xargs perl -pi -e "s|^DIET.*|DIET=\"${DIETHOME}/bin-%{myarch}/diet\"|g" 	 
# compile test suite:
%make_build %makeflags all DEBUG=1
%make_build %makeflags -C inet all DEBUG=1

# run the tests
# getpass requires user input
perl -pi -e "s|^PASS.*|PASS=\"\"|g" runtests.sh
sh ./runtests.sh
cd ..
%endif

%install
make %makeflags DEBUG=1 DESTDIR=%{buildroot} install

%files devel
%doc AUTHOR BUGS CAVEAT CHANGES README THANKS TODO FAQ
%{_bindir}/diet
%{_bindir}/dnsd
%{_bindir}/elftrunc
%{_mandir}/man*/*
%dir %{diethome}
%dir %{diethome}/include
%{diethome}/include/*
%dir %{diethome}/lib-*
%{diethome}/lib-*/*




%changelog
* Mon Jan 25 2021 pterjan <pterjan> 0.34-3.mga8
+ Revision: 1673282
- Fix path for tests
- Fix release
- Try to fix build on arm

* Sat Jan 23 2021 daviddavid <daviddavid> 0.34-2.mga8
+ Revision: 1672935
- disable tests on aarch64 for now
+ neoclust <neoclust>
- Rebuild on mageia 8
+ umeabot <umeabot>
- Mageia 8 Mass Rebuild

* Thu Sep 27 2018 tv <tv> 0.34-1.mga7
+ Revision: 1308401
- new release

* Sun Sep 23 2018 umeabot <umeabot> 0.34-0.20170317.4.mga7
+ Revision: 1297441
- Mageia 7 Mass Rebuild

* Sat Jun 23 2018 wally <wally> 0.34-0.20170317.3.mga7
+ Revision: 1239227
- aarch64: define __clone, make clone a weak alias to it (from Debian)

* Sun Jun 03 2018 wally <wally> 0.34-0.20170317.2.mga7
+ Revision: 1234060
- add aarch64 support

* Tue Jan 09 2018 tv <tv> 0.34-0.20170317.1.mga7
+ Revision: 1191956
- new snapshot
- drop merged patch
- disable patches 23 & 26
- fix testsuite
- replace part of mdkconfig patch by flags

* Wed Sep 20 2017 tv <tv> 0.33-4.20120825.10.mga7
+ Revision: 1156290
- reduce max cpu to 8 as this works locally whereas -j12 fails on BS
- replace patch 37 & part of mdkconfig patch by flags
- drop mips patches

* Thu Feb 04 2016 umeabot <umeabot> 0.33-4.20120825.8.mga6
+ Revision: 935624
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 0.33-4.20120825.7.mga5
+ Revision: 739638
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 0.33-4.20120825.6.mga5
+ Revision: 678738
- Mageia 5 Mass Rebuild

* Sat Oct 19 2013 umeabot <umeabot> 0.33-4.20120825.5.mga4
+ Revision: 523357
- Mageia 4 Mass Rebuild

* Sun Apr 07 2013 rtp <rtp> 0.33-4.20120825.4.mga3
+ Revision: 408939
- fix MYARCH variable to properly be set to 'arm' on 'arm'

* Fri Jan 11 2013 umeabot <umeabot> 0.33-4.20120825.3.mga3
+ Revision: 348767
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Sep 26 2012 tv <tv> 0.33-4.20120825.2.mga3
+ Revision: 297917
- new snapshot
- rediff patches 23 & 305

* Sat Jul 28 2012 tv <tv> 0.33-4.20120330.2.mga3
+ Revision: 275162
- rebuild for new gcc

* Mon Jun 04 2012 tv <tv> 0.33-4.20120330.1.mga3
+ Revision: 254066
- new snapshot

* Mon Feb 27 2012 tv <tv> 0.33-4.20120224.1.mga2
+ Revision: 215630
- new snapshot
- rediff patch 33 (only keep the test) & 200
- drop patches 16, 24, 36, 112, 304, 306-308, 320 (merged) & 3 (useless)
- fix & run test suite

* Sat Feb 25 2012 tv <tv> 0.33-4.20111222.1.mga2
+ Revision: 214700
- new snapshot
- rediff patch 200
- drop patches 40x (merged)

* Sun Feb 19 2012 bertl <bertl> 0.33-4.20110311.3.mga2
+ Revision: 210721
- added various fixes from the ensc branch
- updated clone prototype
- fix off by one in memchr
- ensure max bytes in strftime
- lseek64 for 64-bit (=lseek)
- fix posix_fadvise() implementation

* Mon Jan 23 2012 tv <tv> 0.33-4.20110311.2.mga2
+ Revision: 200128
- bump release
- switch to 0.33 branch
- annotate patches upstreamed

